leetcode - 1769. Minimum Number of Operations to Move All Balls to Each Box

Description

You have n boxes. You are given a binary string boxes of length n, where boxes[i] is '0' if the ith box is empty, and '1' if it contains one ball.

In one operation, you can move one ball from a box to an adjacent box. Box i is adjacent to box j if abs(i - j) == 1. Note that after doing so, there may be more than one ball in some boxes.

Return an array answer of size n, where answer[i] is the minimum number of operations needed to move all the balls to the ith box.

Each answer[i] is calculated considering the initial state of the boxes.

Example 1:

复制代码
Input: boxes = "110"
Output: [1,1,3]
Explanation: The answer for each box is as follows:
1) First box: you will have to move one ball from the second box to the first box in one operation.
2) Second box: you will have to move one ball from the first box to the second box in one operation.
3) Third box: you will have to move one ball from the first box to the third box in two operations, and move one ball from the second box to the third box in one operation.

Example 2:

复制代码
Input: boxes = "001011"
Output: [11,8,5,4,3,4]

Constraints:

复制代码
n == boxes.length
1 <= n <= 2000
boxes[i] is either '0' or '1'.

Solution

Brute Force

Iterate once to get all the indexes of balls, then iterate again to calculate: ∑ ∣ ball_index − i ∣ \sum |\text{ball\_index} - i| ∑∣ball_index−i∣

Time complexity: o ( n 2 ) o(n^2) o(n2)

Space complexity: o ( n ) o(n) o(n)

Prefix sum

Like 238. Product of Array Except Self, we can have left_cnt to denote the number of balls at the left of the current index, when moving one step forward, we have an extra left_cnt cost to move all the balls. We could do the same for right_cnt, and the final result would be left_cost + right_cost.

Time complexity: o ( n ) o(n) o(n)

Space complexity: o ( 1 ) o(1) o(1)

Code

Brute Force

python3 复制代码
class Solution:
    def minOperations(self, boxes: str) -> List[int]:
        ball_indexes = []
        for i in range(len(boxes)):
            if boxes[i] == '1':
                ball_indexes.append(i)
        res = []
        for i in range(len(boxes)):
            cur_res = 0
            for each_ball_index in ball_indexes:
                cur_res += abs(each_ball_index - i)
            res.append(cur_res)
        return res

Prefix sum

python3 复制代码
class Solution:
    def minOperations(self, boxes: str) -> List[int]:
        res = [0] * len(boxes)
        left_cnt = 0
        left_cost = 0
        for i in range(1, len(boxes)):
            if boxes[i - 1] == '1':
                left_cnt += 1
            left_cost += left_cnt
            res[i] += left_cost
        right_cnt = 0
        right_cost = 0
        for i in range(len(boxes) - 2, -1, -1):
            if boxes[i + 1] == '1':
                right_cnt += 1
            right_cost += right_cnt
            res[i] += right_cost
        return res
相关推荐
Y1nhl1 小时前
搜广推校招面经六十四
人工智能·深度学习·leetcode·广告算法·推荐算法·搜索算法
ylfhpy2 小时前
Java面试黄金宝典30
java·数据库·算法·面试·职场和发展
明.2442 小时前
DFS 洛谷P1123 取数游戏
算法·深度优先
简简单单做算法4 小时前
基于mediapipe深度学习和限定半径最近邻分类树算法的人体摔倒检测系统python源码
人工智能·python·深度学习·算法·分类·mediapipe·限定半径最近邻分类树
Tisfy5 小时前
LeetCode 2360.图中的最长环:一步一打卡(不撞南墙不回头) - 通过故事讲道理
算法·leetcode··题解
Espresso Macchiato5 小时前
Leetcode 3500. Minimum Cost to Divide Array Into Subarrays
leetcode·动态规划·leetcode hard·leetcode 3500·leetcode双周赛153
LuckyAnJo5 小时前
Leetcode-100 链表常见操作
算法·leetcode·链表
菜鸡中的奋斗鸡→挣扎鸡5 小时前
第十一届蓝桥杯大赛软件赛省赛C/C++ 大学 B 组
职场和发展·蓝桥杯
双叶8366 小时前
(C语言)虚数运算(结构体教程)(指针解法)(C语言教程)
c语言·开发语言·数据结构·c++·算法·microsoft
工一木子6 小时前
大厂算法面试 7 天冲刺:第5天- 递归与动态规划深度解析 - 高频面试算法 & Java 实战
算法·面试·动态规划